module FundRaise

class ProjectMatch < Project

  def initialize (name, target, funding=0)
    super(name, target, funding)
    @halfway_funded = target / 2
  end
  
  def add_funds(add_funding=25, pledge=false)
    if halfway_funded?
      super(add_funding * 2)
    else
      if (@current_funding + add_funding) >= @halfway_funded
        difference = @current_funding + add_funding - @halfway_funded
        super(difference * 2)
      end
    end
  end
  
  def halfway_funded?
    @current_funding >= @halfway_funded
  end

end

if __FILE__ == $0
  new_match = ProjectMatch.new("Park Fund Matchings", 6000, 2000)
  puts new_match.add_funds(4000)
end

end